
from PySteppables import *
import CompuCell
import sys
class CellDiffusionSteppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=10):
        SteppableBasePy.__init__(self,_simulator,_frequency)
    def start(self):
        
        import CompuCellSetup  
        self.pW=CompuCellSetup.viewManager.plotManager.getNewPlotWindow()
        if not self.pW:
            return
        #Plot Title - properties           
        self.pW.setTitle("ASD")
        self.pW.setTitleSize(12)
        self.pW.setTitleColor("Green") # you may choose different color - type its name
        
        #plot background
        self.pW.setPlotBackgroundColor("orange") # you may choose different color - type its name
        
        # properties of x axis
        self.pW.setXAxisTitle("MCS")
        self.pW.setXAxisTitleSize(10)      
        self.pW.setXAxisTitleColor("blue")  # you may choose different color - type its name            
        
        # properties of y axis
        self.pW.setYAxisTitle("ASD")        
#         self.pW.setYAxisLogScale()
        self.pW.setYAxisTitleSize(10)        
        self.pW.setYAxisTitleColor("red")  # you may choose different color - type its name                                
        
        # choices for style are NoCurve,Lines,Sticks,Steps,Dots
        self.pW.addPlot("ASD",_style='Dots')
        #self.pW.addPlot("DATA SERIES 2",_style='Steps') # you may add more than one data series
        
        # plot MCS
        self.pW.changePlotProperty("ASD","LineWidth",5)
        self.pW.changePlotProperty("ASD","LineColor","red")     
        
        self.pW.addGrid()
        #adding automatically generated legend
        # default possition is at the bottom of the plot but here we put it at the top
        self.pW.addAutoLegend("top")
        
        self.clearFlag=False
        
        
        
        
        # any code in the start function runs before MCS=0
        for cell in self.cellList:
            dict_attrib=CompuCell.getPyAttrib(cell)    
            dict_attrib['COM']=(cell.xCOM,cell.yCOM,cell.zCOM)
        

    def step(self,mcs):        
        ASD=0.0        #average square displacement
        
        numberOfCells=len(self.cellList)
        
        for cell in self.cellList:
            
            dict_attrib=CompuCell.getPyAttrib(cell)    
            comAtStart=dict_attrib['COM']
            
            ASD+=(comAtStart[0]-cell.xCOM)**2\
            +(comAtStart[1]-cell.yCOM)**2\
            +(comAtStart[2]-cell.zCOM)**2        
            
        ASD=ASD/numberOfCells
        print 'MCS=',mcs, 'ASD=',ASD   
        
        #self.pW.eraseAllData() # this is how you erase previous content of the plot
        self.pW.addDataPoint("ASD",mcs,ASD) # arguments are (name of the data series, x, y)
        
        self.pW.showAllPlots() 
        
         